{"openapi":"3.0.0","info":{"title":"017 HR Data API","version":"1.0.0"},"tags":[{"name":"healthcheck"},{"name":"017 HR Data"}],"servers":[{"url":"https://uow-uks-dev-integrations-apim.azure-api.net/W017-HR"}],"security":[{"ApiKeyAuth":[]},{"OAuth2":["clientCredentials"]}],"paths":{"/healthcheck":{"get":{"tags":["healthcheck"],"description":"The healthcheck endpoint provides detailed information about the health of a web service. If each of the components required by the service are healthy, then the service is considered healthy and will return a 200 OK response. If any of the components needed by the service are unhealthy, then a 503 Service Unavailable response will be provided.","responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/HealthcheckTest"},"example":{"name":"servicename","tested_at":"2024-02-29T03:04:19.162Z","result":"passed","duration_millis":100,"additionalProperties":{"childservice1":{"name":"childservice","duration_millis":5.6,"result":"passed","tested_at":"2024-02-29T03:00:39.372Z"},"childservice2":{"name":"childservice2","duration_millis":15.6,"result":"passed","tested_at":"2024-02-29T03:00:39.372Z"}}}}}},"503":{"description":"Service Unavailable","content":{"application/json":{"schema":{"$ref":"#/components/schemas/HealthcheckTest"},"example":{"name":"servicename","tested_at":"2024-02-29T03:04:19.162Z","result":"passed","duration_millis":0,"error":"childservice2 failed","additionalProperties":{"childservice1":{"name":"childservice1","duration_millis":5.6,"result":"passed","tested_at":"2024-02-29T03:00:39.372Z"},"childservice2":{"name":"childservice2","duration_millis":15.6,"result":"failed","tested_at":"2024-02-29T03:00:39.372Z","error":"Unable to connect to stu-talk"}}}}}}}}},"/Stutalk - 017 –  HR Data":{"post":{"description":"Fetching sce_blok codes in bulk","summary":"059 WBS Data - Fetching sce_blok codes in bulk","tags":["059 WBS Data"],"parameters":[{"$ref":"#/components/parameters/bapi-request-id"},{"$ref":"#/components/parameters/bapi-request-timestamp"},{"$ref":"#/components/parameters/bapi-correlation-id"},{"$ref":"#/components/parameters/bapi-channel-id"},{"$ref":"#/components/parameters/bapi-app-id"},{"$ref":"#/components/parameters/bapi-clientsecret"},{"$ref":"#/components/parameters/page"},{"$ref":"#/components/parameters/pagesize"}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/SCE-blok-codes-request"}}}},"responses":{"200":{"$ref":"#/components/responses/sce-block-codes-success-response"},"400":{"$ref":"#/components/responses/BusinessFailureResponse"},"500":{"$ref":"#/components/responses/SystemFailureResponse"}}}},"/module-registrations":{"post":{"description":"Fetching SITS Module Registrations in bulk","summary":"059 WBS Data - Fetching SITS Module Registrations in bulk","tags":["059 WBS Data"],"parameters":[{"$ref":"#/components/parameters/bapi-request-id"},{"$ref":"#/components/parameters/bapi-request-timestamp"},{"$ref":"#/components/parameters/bapi-correlation-id"},{"$ref":"#/components/parameters/bapi-channel-id"},{"$ref":"#/components/parameters/bapi-app-id"},{"$ref":"#/components/parameters/bapi-clientsecret"},{"$ref":"#/components/parameters/page"},{"$ref":"#/components/parameters/pagesize"}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Module-registrations-request"}}}},"responses":{"200":{"$ref":"#/components/responses/module-registrations-success-response"},"400":{"$ref":"#/components/responses/BusinessFailureResponse"},"500":{"$ref":"#/components/responses/SystemFailureResponse"}}}}},"components":{"parameters":{"bapi-correlation-id":{"name":"bapi-correlation-id","in":"header","description":"Correlation ID is a unique identifier that is unique for a single converstaion which can be made up of one or more request/response messages. It can also be passed to further downstream systems or used by the consuming app to correlate messages.","required":true,"schema":{"type":"string"},"example":"uuid:6b499780-505a-4074-972d-e32269df2a4e"},"bapi-channel-id":{"name":"bapi-channel-id","in":"header","description":"Channel ID is a unique identifier that is unique for a business or comms channel.","required":true,"schema":{"type":"string"},"example":"WMG"},"bapi-app-id":{"name":"bapi-app-id","in":"header","description":"App ID is unique for a api consuming application.","required":true,"schema":{"type":"string"},"example":"WMGProjectSelector"},"bapi-clientsecret":{"name":"bapi-clientsecret","in":"header","description":"ClientSecret associated with the bapi-app-id.","required":true,"schema":{"type":"string"},"example":"12F722BE-2EFF-2559-A1E8-274D52E55EA086"},"bapi-request-id":{"name":"bapi-request-id","in":"header","description":"Request ID is a unique identifier that is unique for a single request/response message and will be used to map log and error message to consumer's request.","required":true,"schema":{"type":"string"},"example":"uuid:f81d4fae-8jan-22e5-a765-00a0c91e7ee7"},"bapi-request-timestamp":{"name":"bapi-request-timestamp","in":"header","description":"Used to reflect the time when the message was created. ","required":true,"schema":{"type":"string","format":"date-time"},"example":"2021-02-05T16:30:47Z"},"page":{"name":"page","in":"query","required":true,"schema":{"type":"integer","minimum":1,"default":1,"description":"page number from fetched records"},"example":1},"pagesize":{"in":"query","name":"pagesize","required":true,"schema":{"type":"integer","minimum":10,"maximum":4000,"default":1000,"description":"number size of fetched records in single response","example":1000}}},"headers":{"bapi-correlation-id":{"description":"CorrelationID is a unique identifier that is unique for a single request/response message and will be used to map log and error message to consumer’s request.","schema":{"type":"string"},"example":"uuid:6b499780-505a-4074-972d-e32269df2a4e","required":true},"bapi-request-id":{"description":"RequestID is a unique identifier that is unique for a single request/response message and will be used to map log and error message to consumer’s request.","schema":{"type":"string"},"example":"uuid:f81d4fae-8jan-22e5-a765-00a0c91e7ee7","required":true},"bapi-response-timestamp":{"description":"Used to reflect the time when the message was created within this service for the response. Example value 2014-12-17T09:30:87Z","schema":{"type":"string"},"example":"2014-12-17T09:30:87Z"}},"responses":{"sce-block-codes-success-response":{"description":"Success data Response","headers":{"bapi-request-id":{"$ref":"#/components/headers/bapi-request-id"},"bapi-correlation-id":{"$ref":"#/components/headers/bapi-correlation-id"},"bapi-response-timestamp":{"$ref":"#/components/headers/bapi-response-timestamp"}},"content":{"application/json":{"schema":{"$ref":"#/components/schemas/SCE-blok-codes-success-response"}}}},"module-registrations-success-response":{"description":"Success data Response","headers":{"bapi-request-id":{"$ref":"#/components/headers/bapi-request-id"},"bapi-correlation-id":{"$ref":"#/components/headers/bapi-correlation-id"},"bapi-response-timestamp":{"$ref":"#/components/headers/bapi-response-timestamp"}},"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Module-registrations-success-response"}}}},"BusinessFailureResponse":{"description":"Bad Request, consumers will get this error if the request does not contain valid headers and inputs.\n","headers":{"bapi-request-id":{"$ref":"#/components/headers/bapi-request-id"},"bapi-correlation-id":{"$ref":"#/components/headers/bapi-correlation-id"},"bapi-response-timestamp":{"$ref":"#/components/headers/bapi-response-timestamp"}},"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Failure-response"},"example":{"result":"failure","data":{"code":1001,"message":"Failure","detail":"Validation Exception"}}}}},"SystemFailureResponse":{"description":"Internal Server Error.\n","headers":{"bapi-request-id":{"$ref":"#/components/headers/bapi-request-id"},"bapi-correlation-id":{"$ref":"#/components/headers/bapi-correlation-id"},"bapi-response-timestamp":{"$ref":"#/components/headers/bapi-response-timestamp"}},"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Failure-response"},"example":{"result":"failure","data":{"code":9001,"message":"Failure Message","detail":"System Exception"}}}}}},"schemas":{"Error":{"properties":{"code":{"type":"string","description":"Code represents the fault code. The full list of codes can be found in the MSA sharepoint.","example":1001},"message":{"type":"string","example":"Error","description":"Technical descriptions associated with errors that assist operation support team/processes but will NOT be passed back to consumer."},"detail":{"type":"string","example":"Validation Exception","description":"Technical descriptions associated with errors that assist operation support team/processes but will NOT be passed back to consumer."}}},"Pagination":{"type":"object","properties":{"total_records":{"type":"integer","minimum":10},"current_page":{"type":"integer","minimum":1},"total_pages":{"type":"integer","minimum":1},"total_records_current_page":{"type":"integer","minimum":0},"next_page":{"type":"integer","minimum":1},"prev_page":{"type":"integer","minimum":1}},"required":["total_records","current_page","total_pages","next_page","page_record_count"]},"Failure-response":{"type":"object","properties":{"result":{"type":"string","example":"success","enum":["success","failure"]},"data":{"$ref":"#/components/schemas/Error"}}},"HealthcheckTest":{"required":["name","tested_at","result","duration_millis"],"properties":{"name":{"type":"string"},"tested_at":{"type":"string","format":"date-time","description":"The IS08601 date and time representing the start of the test"},"result":{"type":"string","description":"The result of running the test","enum":["passed","failed"]},"duration_millis":{"type":"number","description":"The number of milliseconds that the test took to executed"},"error":{"type":"string","description":"A string describing any error conditions that were experienced"},"additionalProperties":{"type":"object"}}},"SCE-blok-codes-request":{"type":"object","properties":{"academicYearCode":{"type":"string","description":"SCE_AYRC - Academic year code. A code which identifies the year in which the student is enrolling on the course block occurrence. This field is validated by an entry in the Academic Year (AYR) table","maxLength":5,"minLength":5,"example":"23/24"},"studentCodes":{"type":"array","description":"SCE_STUC - Student Code","minItems":1,"maxItems":4000,"items":{"type":"string","maxLength":7,"minLength":7,"example":"1234567"}},"routeCodes":{"type":"array","description":"SCE_ROUC - The student's CAMS route. This field will normally be completed by transferring the data from the student's CAMS SPR record using the appropriate option from within the CAMS SRS Administration menu (CAS). It is required on the SCE record for the HESA return and the transfer from CAMS therefore should not take place until the data is stable. After any initial transfer from CAMS this field should remain the same until after the complete reporting cycle to HESA, even if the programme route on the student's SPR record changes. If you do not do this it will cause confusion as to whether the student has withdrawn/transferred.","minItems":1,"maxItems":4000,"items":{"type":"string","minLength":1,"maxLength":12,"example":"N403"}}},"required":["academicYearCode","studentCodes","routeCodes"]},"SCE-blok-codes-success-response":{"type":"object","properties":{"result":{"type":"string","example":"success","enum":["success","failure"]},"pagination":{"$ref":"#/components/schemas/Pagination"},"data":{"type":"array","items":{"$ref":"#/components/schemas/SitsSceBlok"}}}},"Module-registrations-request":{"type":"object","properties":{"academicYearCode":{"type":"string","description":"AYR_CODE - Academic year code. A code which identifies the year in which the student is enrolling on the course block occurrence. This field is validated by an entry in the Academic Year (AYR) table","maxLength":5,"minLength":5,"example":"23/24"},"sprCodes":{"type":"array","description":"spr_code - Student Join Code. A unique code identifying the student scheduled onto the module occurrence. This field is validated by an entry in the Student Table (SPR) table","minItems":1,"maxItems":4000,"items":{"type":"string","maxLength":9,"minLength":9,"example":"1234567/1"}}},"required":["academicYearCode","sprCodes"]},"Module-registrations-success-response":{"type":"object","properties":{"result":{"type":"string","example":"success","enum":["success","failure"]},"pagination":{"$ref":"#/components/schemas/Pagination"},"data":{"type":"array","items":{"$ref":"#/components/schemas/SitsModuleRegistrations"}}}},"SitsSceBlok":{"type":"object","description":"Fetching sce_blok codes in bulk","properties":{"studentCode":{"type":"string","description":"SCE_STUC. This field is validated by an entry in the Student (STU) table","maxLength":7,"minLength":7,"example":1234567},"routeCode":{"type":"string","description":"SCE_ROUC - The student's CAMS route. This field will normally be completed by transferring the data from the student's CAMS SPR record using the appropriate option from within the CAMS SRS Administration menu (CAS). It is required on the SCE record for the HESA return and the transfer from CAMS therefore should not take place until the data is stable. After any initial transfer from CAMS this field should remain the same until after the complete reporting cycle to HESA, even if the programme route on the student's SPR record changes. If you do not do this it will cause confusion as to whether the student has withdrawn/transferred.","maxLength":4,"minLength":4,"example":"N403"},"block":{"type":"string","description":"SCE_BLOK - SRS Course Block (2 chars) The block within the course on which the student is enrolled","minLength":1,"maxLength":2,"example":"1"},"academicYearCode":{"type":"string","description":"ACE_BLOK - Academic year code. A code which identifies the year in which the student is enrolling on the course block occurrence. This field is validated by an entry in the Academic Year (AYR) table","maxLength":5,"minLength":5,"example":"23/24"}}},"SitsModuleRegistrations":{"type":"object","description":"SITS Module Registrations","properties":{"sprCode":{"type":"string","description":"spr_code - Student Join Code. A unique code identifying the student scheduled onto the module occurrence. This field is validated by an entry in the Student Table (SPR) table","maxLength":9,"minLength":9,"example":"1234567/1"},"moduleCode":{"type":"string","description":"mod_code - Module Code. A code defining the module. This field is validated by an entry in the Module Table (MOD) table","maxLength":8,"minLength":8,"example":"IB9JA-15"},"assessmentGroup":{"type":"string","description":"smo_agrp - A value in this field indicates that the student belongs to an Assessment Group. Assessment groups are intended to allow institutions the possibility of assessing students on the same module occurrence in different ways, without having to define separate module assessment patterns to cover each eventuality. Assessment Groups are defined within the Module Assessment Body records. Assign the same alpha character to each assessment item within the group (Agr Group field). The % field needs to reflect the weight of the item within the assessment group - the sum of the assessment group elements must equal 100%. The qualifying mark can vary between the elements which make up an assessment group. For example: Assessment Group A is 100% exam Assessment Group B is 50% exam (Qualifying Mark 35) and 50% coursework (Qualifying Mark 40)","maxLength":2,"minLength":1,"example":"D4"},"academicYearCode":{"type":"string","description":"Academic year code. A code which identifies the year in which the student is enrolling on the course block occurrence. This field is validated by an entry in the Academic Year (AYR) table","maxLength":5,"minLength":5,"example":"23/24"},"occurrence":{"type":"string","description":"mav_occur - Occurrence","maxLength":2,"minLength":1,"example":"A"},"actualMark":{"type":"number","description":"smr_actm - Actual Mark"},"agreedMark":{"type":"number","description":"smo_agrm - Agreed Mark"}}}},"securitySchemes":{"BearerAuth":{"type":"http","scheme":"bearer"},"ApiKeyAuth":{"type":"apiKey","in":"header","name":"X-API-Key"},"OAuth2":{"type":"oauth2","flows":{"clientCredentials":{"tokenUrl":"https://example.com/oauth/token","scopes":{"read":"Grants read access","write":"Grants write access"}}}}}}}